#include <iostream.h>
//using namespace std;

class D  {
private:
	float x,y,z;
public:
	D() { cout << "costruttore di default" << endl; x=0,y=0,z=0; }
	D(float i,float j,float k) {cout <<"costruttore parametrizzato " << endl; x=i, y=j,z=k; }
//	D(const D &D) { cout << "costruttore di copie" << endl;} ; // ATTENZIONE
	friend D operator+(class D, class D);
//	D operator+ (class D);
	D operator= (class D);
	D operator ++ ();
	D operator ++ (int); // secondo parametro formale di tipo intero
	void mostra() { cout << x << endl << y << endl << z << endl;}
	~D() { cout << "3D distrutto " << endl;}
};

/*
con funzione membro
  D D::operator+(D op2)
 { D temp;
	temp.x=x+op2.x;
		temp.y=y+op2.y;
			temp.z=z+op2.z;
			return temp;
 };
 */

// con funzione friend 

D operator+(D op1, D op2)
 { D temp;
	temp.x=op1.x+op2.x;
		temp.y=op1.y+op2.y;
			temp.z=op1.z+op2.z;
			return temp;
 };


D D::operator=(D op2)
 { x=op2.x;
   y=op2.y;
   z=op2.z;
   return *this;
 };


D D::operator ++ ()
{
	//x++;
	//y++;
	//z++;
	cout <<" i valori sono "<< endl <<	x++ << endl << 	y++ << endl << z++ << endl;
	return *this;
}

D D::operator ++ (int notused) 
{
	D temp = *this;
	cout <<" i valori sono "<< endl <<	++x << endl << 	++y << endl << ++z << endl;
	//x++;
	//y++;
	//z++;
	return temp;
}

int main()
{
	D a(1,2,3), b(10,10,10),c;
	a.mostra();
	a++;
	a.mostra();
	b.mostra();
	++b;
	b.mostra();
	c.mostra();
	c=a+b;
	c.mostra();
	c=a+b+c;
	c.mostra();
	//(a+b).mostra();
	c=b=a;
	c.mostra();
	b.mostra();
	return 0;
}

/* esempio di operatore ++ con funzione membro

D D::operator ++ ()
{
	x++;
	y++;
	z++;
	return *this;
}

D D::operator ++ (float notused) suffissa con funzione membro
{
	D temp = *this;
	y++;
	z++;
	return temp;
}


D D::operator ++ (D &op1) con funzione friend 
{
	op1.x++;
	op1.y++;
	op1.z++;
	return op1;
}

 D D::operator ++ (D &op1, float notused) suffissa con funzione friend 
{
	
	D temp= op1;
	op1.x++;
	op1.y++;
	op1.z++;
	return temp;
}

Overloading dell'operatore uguale per evitare problemi di allocazione della memoria


*/
