// STL --- accede agli elementi di un vettore tramite un iteratore

#include <iostream>
#include <vector>
#include <cctype>
using namespace std;


int main()
{
	vector<char> v(10);       // crea un vettore di lunghezza 10
	vector<char>::iterator p; // crea un iteratore
	int i;


	// assegna un valore agli elementi di un vettore
	p=v.begin();
	i=0;
	while(p != v.end()) {
		*p = i + 'a';
		p++;
		i++;
	}

	// visualizza il contenuto del vettore
	cout << "Contenuto originale =\n";
	p=v.begin();
	while(p != v.end()) {
		cout << *p << " ";
		p++;
	}
	cout << endl;

	// cambia il contenuto del vettore
	p=v.begin();
	while(p != v.end()) {
		*p = toupper(*p);
		p++;
	}

	// visualizza il contenuto del vettore
	cout << "Contenuto modificato =\n";
	p=v.begin();
	while(p != v.end()) {
		cout << *p << " ";
		p++;
	}

	cout << endl;

	return 0;
}